package com.elab.core.async.pruducer;

import com.elab.core.async.RealTaskExecutor;
import com.elab.core.async.SchedulingTaskExecutor;
import com.elab.core.async.TaskStoreProcess;
import com.elab.core.async.model.TaskStoreData;
import com.elab.core.async.store.TaskExecutorDecoration;
import com.elab.core.async.store.TaskExecutorQueue;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 实时生产者
 *
 * @author ： liukx
 * @time ： 2020/8/6 - 11:17
 */
public class TaskProducer {

    private Logger logger = LoggerFactory.getLogger(TaskProducer.class);

    private TaskExecutorQueue taskExecutorQueue;

    private TaskStoreProcess handler;

    public TaskProducer(TaskExecutorQueue taskExecutorQueue) {
        this.taskExecutorQueue = taskExecutorQueue;
    }

    public void setHandler(TaskStoreProcess handler) {
        this.handler = handler;
    }

    public void addRealTimeQueue(RealTaskExecutor taskExecutor) {
        addRealTimeQueue(taskExecutor, null);
    }

    public void addRealTimeQueue(RealTaskExecutor taskExecutor, TaskStoreData taskStoreData) {
        Object id = null;
        if (taskStoreData != null) {
            id = this.handler.add(taskStoreData);
        }
        TaskExecutorDecoration taskExecutorDecoration = new TaskExecutorDecoration(id, taskExecutor);
        boolean isConsumer = this.taskExecutorQueue.getRealTimeQueue().add(taskExecutorDecoration);

        if (isConsumer) {
            logger.debug("加入异步消费队列");
        }
    }

    public void addSchedulingList(SchedulingTaskExecutor schedulingTaskExecutor) {
        this.taskExecutorQueue.getSchedulingList().add(schedulingTaskExecutor);
    }


}
