package com.elab.core.async.pruducer;

import com.elab.core.async.consumer.TaskConsumer;
import com.elab.core.async.store.TaskExecutorQueue;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;

public class TaskProducerTest {
    private TaskProducer producer;

    @Before
    public void init() {
        TaskExecutorQueue queue = new TaskExecutorQueue();
        TaskConsumer taskConsumer = new TaskConsumer(queue);
        taskConsumer.startRealTimeConsumer();
        taskConsumer.startSchedulingConsumer(30);
        producer = new TaskProducer(queue);
    }

    @Test
    public void addRealTimeQueue() throws IOException {
        for (int i = 0; i < 10; i++) {
            int finalI = i;
            System.out.println("==业务执行开始==" + i);
            producer.addRealTimeQueue(() -> {
                System.out.println("-------操作异步开始----------" + finalI);
                try {
                    Thread.sleep(5000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                System.out.println("-----异步操作结束-----------" + finalI);
            });
            System.out.println("==业务执行完成==" + i);
        }
        System.in.read();
    }

    @Test
    public void addSchedulingList() throws IOException {
        for (int i = 0; i < 10; i++) {
            int finalI = i;
            System.out.println("==业务执行开始==" + i);
            producer.addSchedulingList(() -> {
                System.out.println("-------操作异步开始----------" + finalI);
                try {
                    Thread.sleep(5000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                System.out.println("-----异步操作结束-----------" + finalI);
            });
            System.out.println("==业务执行完成==" + i);
        }
        System.in.read();
    }
}
